<?php
/*
Plugin Name: SimpleRSSEmbed
Plugin URI: http://christopher.murtagh.name/2011/12/12/simplerssembed-my-first-plugin/
Description: A very simple RSS plugin that allows you to embed RSS feeds into a page or a post, doesn't use a deprecated RSS library, and worked with Atom feeds that didn't have summary/descriptions.
Version: 0.1
License: GPL2+
Author: Christopher Murtagh
Author URI: http://christopher.murtagh.name/
*/

function simplerssembed ($argv) {

	$output = '';

	extract(shortcode_atts(
		array( 'rssfeed' => 'http://wordpress.org/news/feed/',
			'rssitems' => '5',
			'rssmaxdescription' => '400',
			'rsscssclass' => 'rssitem',
			'rsslinktarget' => '_self',
			'rsscacheduration' => '3600',
			'rssdateformat' => 'j F Y | g:i a'
		), $argv ) );


	require_once( ABSPATH . WPINC . '/class-simplepie.php' );

	$feed = new SimplePie();
	$feed->set_feed_url($rssfeed);
	$feed->handle_content_type();
	$feed->set_cache_duration($rsscacheduration);
	$feed->set_cache_location(ABSPATH . 'wp-content/plugins/simplerssembed/cache');
	$feed->init();
 
	foreach ($feed->get_items(0, $rssitems) as $item){	

		$description = substr(strip_tags($item->get_description()), 0, $rssmaxdescription);

		if(strlen($description) == $rssmaxdescription){
			$truncatepoint = strrpos($description, ' ');
			$description = substr(strip_tags($description), 0, $truncatepoint).' [...]';
		}

		$output .= '<div class="'.$rsscssclass.'">';
		$output .= '<h3><a target="'.$rsslinktarget.'" href="'. $item->get_permalink() . '">'.$item->get_title(). '</a></h3>';
		$output .= '<p class="rssitemdescription">'.$description.'</p>';
		$output .= '<p class="rssitemdate">Posted on '. $item->get_date($rssdateformat).'</p>';
		$output .= '</div>';
        }

	return $output;
}

add_shortcode("simplerssembed", "simplerssembed");

?>
